function [animal_ID, unit_depth, track_number, exp_type] = getInfo(curFile)

h = load(curFile);

animal_ID = h.Header.animal_ID;

if ischar(h.Header.start_depth) 
start_depth = str2num(h.Header.start_depth);
else
start_depth = h.Header.start_depth;
end

if ischar(h.Header.unit_depth) 
unit_depth = str2num(h.Header.unit_depth);
else
unit_depth = h.Header.unit_depth;
end
  

unit_depth = abs(start_depth-unit_depth);

track_number = h.Header.track_number;
exp_type = h.Header.exp_type;
end


